//
//  Shader2D.fsh
//  Game Engine
//
//  Created by Siema on 18/06/2012.
//  Copyright (c) 2012 Alien Worm. All rights reserved.
//

varying lowp vec4 vv4Color;
varying lowp vec2 vv2UV;

uniform sampler2D tex;

uniform lowp float lightX;
uniform lowp float lightY;
uniform lowp float lightZ;

void main()
{
    //gl_FragColor = texture2D(tex, vv2UV) * vv4Color;
    
    lowp vec4 clr;
    lowp float d1;
    lowp float d2;
    
    
    // do specularity
    //lowp float specular;
    //lowp float dotProduct;
    //lowp vec3 r;
    lowp vec3 normal;
    lowp vec3 light;
    
    clr = 2.0 * texture2D(tex, vv2UV) - 1.0;
    normal = vec3(clr.r, clr.g, clr.b);
    light = vec3(lightX, lightY, lightZ);
    
    d1 = dot( light, normal );
    d1 = clamp(d1, 0.0, 1.0);
    
    d2 = dot( vec3(-lightX, -lightY, lightZ), normal );
    d2 = clamp(d2, 0.0, 1.0);
    
    //specular = SpecularIntensity * SpecularColor * max(pow(dotProduct, Shininess), 0) * length(input.Color)
    
    // specularity
    //r = normalize(2.0 * dot(light, normal) * normal - light);
    //dotProduct = dot(r, vec3(0, 0, 1));
    //specular = max(pow(dotProduct, 200), 0); // Shininess =200
    
    gl_FragColor = vec4(0.3*d1 + 1.0*d2, // + specular,
                        0.7*d1 + 0.55*d2, // + specular,
                        1.0*d1 + 0.43*d2, // + specular,
                        1.0
                        );
}
