//
//  Shader2D.fsh
//  Game Engine
//
//  Created by Siema on 18/06/2012.
//  Copyright (c) 2012 Alien Worm. All rights reserved.
//

varying lowp vec4 vv4Color;
varying lowp vec2 vv2UV;

uniform sampler2D tex;

#define SH_RADIUS 0.25
#define SH_RADIUS_SQUARE (SH_RADIUS*SH_RADIUS)

#define SH_RADIUS_2 0.26
#define SH_RADIUS_SQUARE_2 (SH_RADIUS_2*SH_RADIUS_2)

void main()
{
    lowp float r = 0.0;
    lowp float t;
    
    if (vv2UV.x < SH_RADIUS)   // lewa strona
    {
        if (vv2UV.y < SH_RADIUS)   // dol
        {
            r = (vv2UV.x-SH_RADIUS)*(vv2UV.x-SH_RADIUS) + (vv2UV.y-SH_RADIUS)*(vv2UV.y-SH_RADIUS);
        }
        else if (vv2UV.y > 1.0-SH_RADIUS)  // gora
        {
            r = (vv2UV.x-SH_RADIUS)*(vv2UV.x-SH_RADIUS) + (vv2UV.y-1.0+SH_RADIUS)*(vv2UV.y-1.0+SH_RADIUS);
        }
    }
    else if (vv2UV.x > 1.0-SH_RADIUS)  // prawa strona
    {
        if (vv2UV.y > 1.0-SH_RADIUS)   // gora
        {
            r = (vv2UV.x-1.0+SH_RADIUS)*(vv2UV.x-1.0+SH_RADIUS) + (vv2UV.y-1.0+SH_RADIUS)*(vv2UV.y-1.0+SH_RADIUS);
        }
        else if (vv2UV.y < SH_RADIUS)  // dol
        {
            r = (vv2UV.x-1.0+SH_RADIUS)*(vv2UV.x-1.0+SH_RADIUS) + (vv2UV.y-SH_RADIUS)*(vv2UV.y-SH_RADIUS);
        }
    }
    
    // zamiana na grayscale
//    gray = 1.2 * dot(gl_FragColor.rgb, vec3(0.299, 0.587, 0.114));
//    gl_FragColor = vec4(gray, gray, gray, gl_FragColor.a);
    
    gl_FragColor = texture2D(tex, vv2UV) * vv4Color;
    
    if (r > SH_RADIUS_SQUARE)
    {
        t = (SH_RADIUS_SQUARE_2 - r) / (SH_RADIUS_SQUARE_2 - SH_RADIUS_SQUARE);
        gl_FragColor = vec4(gl_FragColor.x, gl_FragColor.y, gl_FragColor.z, t);
    }
}
