//
//  Shader2D.fsh
//  Game Engine
//
//  Created by Siema on 18/06/2012.
//  Copyright (c) 2012 Alien Worm. All rights reserved.
//

varying lowp vec4 vv4Color;
varying lowp vec2 vv2UV;

uniform sampler2D tex;

uniform lowp float frameRadiusSQ;
uniform lowp float frameRadiusSQ2;

#define SH_RADIUS 0.24
#define SH_RADIUS_SQUARE (SH_RADIUS*SH_RADIUS)

#define SH_RADIUS_2 0.25
#define SH_RADIUS_SQUARE_2 (SH_RADIUS_2*SH_RADIUS_2)

#define SH_GRAY 0.5

void main()
{
    lowp float r = 0.0;
    lowp float t;
    lowp float w;
    
    lowp vec4 c;
    
    if (vv2UV.x < SH_RADIUS)   // lewa strona
    {
        if (vv2UV.y < SH_RADIUS)   // dol
        {
            r = (vv2UV.x-SH_RADIUS)*(vv2UV.x-SH_RADIUS) + (vv2UV.y-SH_RADIUS)*(vv2UV.y-SH_RADIUS);
        }
        else if (vv2UV.y > 1.0-SH_RADIUS)  // gora
        {
            r = (vv2UV.x-SH_RADIUS)*(vv2UV.x-SH_RADIUS) + (vv2UV.y-1.0+SH_RADIUS)*(vv2UV.y-1.0+SH_RADIUS);
        }
    }
    else if (vv2UV.x > 1.0-SH_RADIUS)  // prawa strona
    {
        if (vv2UV.y > 1.0-SH_RADIUS)   // gora
        {
            r = (vv2UV.x-1.0+SH_RADIUS)*(vv2UV.x-1.0+SH_RADIUS) + (vv2UV.y-1.0+SH_RADIUS)*(vv2UV.y-1.0+SH_RADIUS);
        }
        else if (vv2UV.y < SH_RADIUS)  // dol
        {
            r = (vv2UV.x-1.0+SH_RADIUS)*(vv2UV.x-1.0+SH_RADIUS) + (vv2UV.y-SH_RADIUS)*(vv2UV.y-SH_RADIUS);
        }
    }
    
    if (vv2UV.x < 0.0 || vv2UV.x > 1.0 || vv2UV.y < 0.0 || vv2UV.y > 1.0)
        gl_FragColor = vec4(SH_GRAY, SH_GRAY, SH_GRAY, 1.0);
    else
        gl_FragColor = texture2D(tex, vv2UV) * vv4Color;
    
    if (r > SH_RADIUS_SQUARE)
    {
        w = 1.0;
        if (r > frameRadiusSQ)
            w = (frameRadiusSQ2 - r) / (frameRadiusSQ2 - frameRadiusSQ);
        
        gl_FragColor = vec4(SH_GRAY, SH_GRAY, SH_GRAY, w);
        
        t = (SH_RADIUS_SQUARE_2 - r) / (SH_RADIUS_SQUARE_2 - SH_RADIUS_SQUARE);
        if (t > 0.0)
        {
            c = texture2D(tex, vv2UV) * vv4Color;
            gl_FragColor = mix(gl_FragColor, vec4(c.x, c.y, c.z, 1.0), t);
        }
    }
}

