//
//  ShaderMask.fsh
//  Game Engine
//

varying lowp vec4 vv4Color;
varying lowp vec2 vv2UV;
varying lowp vec2 vv2UVMask;

uniform sampler2D tex;
uniform lowp int maskChannel;

void main()
{
    lowp vec4 maskColor;
    
    gl_FragColor = texture2D(tex, vv2UV) * vv4Color;
    maskColor = texture2D(tex, vv2UVMask);
    
    gl_FragColor = vec4(gl_FragColor.r, gl_FragColor.g, gl_FragColor.b, gl_FragColor.a * maskColor[maskChannel]);
}