//
//  ShaderSDF.fsh
//  Game Engine
//
//  Created by Siema on 18/06/2012.
//  Copyright (c) 2012 Alien Worm. All rights reserved.
//

varying lowp vec4 vv4Color;
varying lowp vec2 vv2UV;

uniform sampler2D tex;

uniform lowp float cutoffScale;
uniform lowp float outlineWidthCutoff;
uniform int useGlow;

uniform lowp vec3 txtColor;
uniform lowp vec3 outlineColor;

void main()
{
    lowp float dist;
    lowp float clrMix;
    lowp float alpha;

    dist = texture2D(tex, vv2UV).r;
    clrMix = smoothstep(0.5-cutoffScale, 0.5+cutoffScale, dist);
    
    if (useGlow > 0 && outlineWidthCutoff<0.5)
    {
        // glow falloff
        alpha = (clamp(dist, outlineWidthCutoff, 0.5) - outlineWidthCutoff) * (1.0 / (0.5-outlineWidthCutoff));
    }
    else
    {
        // lub smoothstep dla linii lub braku linii
        alpha = smoothstep(outlineWidthCutoff-cutoffScale, outlineWidthCutoff+cutoffScale, dist);
    }
    
    // uzyc mix lub lerp
    gl_FragColor = vec4(txtColor*clrMix + outlineColor*(1.0-clrMix), alpha * vv4Color.a);
}



//dist = texture2D(tex, vv2UV).r;
//alpha = smoothstep(0.5-cutoffScale, 0.5+cutoffScale, dist);

//gl_FragColor = vec4(vv4Color.rgb, alpha * vv4Color.a);
